{% extends "base.html" %}

{% load humanize %}
{% block title %} - {% trans "Станция" %} {{ station.id }}{% endblock %}

{% block css %}
<link rel="stylesheet"
  href="{% static 'lib/bootstrap-select/dist/css/bootstrap-select.min.css' %}">
<link rel="stylesheet"
  href="{% static 'lib/@fancyapps/ui/dist/fancybox/fancybox.css' %}">
<link rel="stylesheet"
  href="{% static 'lib/jquery-ui/dist/themes/base/jquery-ui.min.css' %}">
<link rel="stylesheet"
  type="text/scss"
  href="{% static 'css/pages/station_view.scss' %}">
{% endblock css %}

{% block body-class %}class="station_view"{% endblock %}

{% block content %}
<section class="container block-h1">
  <div class="btn-back"><a href="{% url 'base:stations_list' %}">{% trans "Назад" %}</a></div>
  <h1 id="station-info"
    data-name="{{ station.name }}"
    data-id="{{ station.id }}"
    data-lng="{{ station.lng }}"
    data-lat="{{ station.lat }}"
    data-schedule="{{ can_schedule|yesno:'true,false' }}"
    data-new-obs="{% url 'base:observation_new' %}"
    data-status="{{ station.get_status_display|lower }}">
    {{ station.name }} <span class="color-blue">#{{ station.id }}</span>
  </h1>
  <div class="row subtitle">
    <div class="utc-text"><span class="bi bi-clock"> {% trans "Время указано в UTC" %}</span></div>
    {% if request.user == station.owner %}
    <a id="obs-delete"
      class="btn btn-small btn-outline-blue"
      role="button"
      title="{% trans 'Редактировать станцию' %}"
      data-toggle="tooltip"
      href="{% url 'base:station_edit' station_id=station.id %}">
      <span class="bi bi-pencil-square"
        aria-hidden="true"></span> {% trans "Изменить" %}
    </a>
    {% endif %}
  </div>
</section>
<section class="block-station-data">
  <div class="container">
    <ul class="nav-tabs">
      <li class="nav-item active"><a href="#tab-station-info"
          type="button"
          data-toggle="tab"
          data-parent-tab="stationTabs"
          data-target-tab="tab-station-info">{% trans "Информация" %}</a></li>
      {% if request.user == station.owner and station.client_id %}
      <li class="nav-item"><a href="#tab-configuration"
          type="button"
          data-toggle="tab"
          data-parent-tab="stationTabs"
          data-target-tab="tab-configuration">{% trans "Конфигурация" %}</a></li>
      {% endif %}
      <li class="nav-item"><a href="#tab-future-passes"
          type="button"
          data-toggle="tab"
          data-parent-tab="stationTabs"
          data-target-tab="tab-future-passes">{% trans "Запланировать наблюдения" %}</a></li>
      <li class="nav-item"><a href="#tab-station-log"
          type="button"
          data-toggle="tab"
          data-parent-tab="stationTabs"
          data-target-tab="tab-station-log">{% trans "Журнал станции" %}</a></li>
      <li class="nav-item"><a href="#tab-station-stat"
          type="button"
          data-toggle="tab"
          data-parent-tab="stationTabs"
          data-target-tab="tab-station-stat">{% trans "Статистика станции" %}</a></li>
      {% if request.user == station.owner %}
      <li class="nav-item"><a href="#tab-auto-scheduling"
          type="button"
          data-toggle="tab"
          data-parent-tab="stationTabs"
          data-target-tab="tab-auto-scheduling">{% trans "Автоматический планировщик" %}</a></li>
      {% endif %}
    </ul>
    <div id="stationTabs"
      class="tab-content">
      <div class="tab-pane active"
        id="tab-station-info">
        <div class="row justify-content-between content">
          <div class="col information-block__table">
            <div class="row">
              <div class="title">{% trans "Владелец" %}</div>
              <div class="description">
                {% if station.owner %}
                <a href="{% url 'users:view_user' username=station.owner.username %}">
                  {{ station.owner.displayname }}
                </a>
                {% else %}
                <div class="empty-val"></div>
                {% endif %}
              </div>
            </div>
            {% if station.qthlocator %}
            <div class="row">
              {% if station.qthlocator %}
              <div class="title">{% trans "QTH-локатор" %}</div>
              <div class="description">
                {{ station.qthlocator }}
                {% else %}
                <div class="empty-val"></div>
                {% endif %}
              </div>
            </div>
            {% endif %}
            {% if station.lat %}
            <div class="row">
              <div class="title">{% trans "Координаты (шир., долг.)" %}</div>
              <div class="description">
                {% if station.lat %}
                {{ station.lat|floatformat:-3 }}°, {{ station.lng|floatformat:-3 }}°
                {% else %}
                <div class="empty-val"></div>
                {% endif %}
              </div>
            </div>
            {% endif %}
            {% if station.alt %}
            <div class="row">
              <div class="title">{% trans "Высота" %}</div>
              <div class="description">
                {% if station.alt %}
                {{ station.alt }} {% trans "м" %}
                {% else %}
                <div class="empty-val"></div>
                {% endif %}
              </div>
            </div>
            {% endif %}
            {% if station.horizon %}
            <div class="row">
              <div class="title">{% trans "Минимальный горизонт" %}</div>
              <div class="description">
                {% if station.horizon %}
                {{ station.horizon }}°
                {% else %}
                <div class="empty-val"></div>
                {% endif %}
              </div>
            </div>
            {% endif %}
            {% if station.target_utilization %}
            <div class="row">
              <div class="title">{% trans "Допустимая нагрузка" %}</div>
              <div class="description">
                {% if station.target_utilization %}
                {{ station.target_utilization }} %
                {% else %}
                <div class="empty-val"></div>
                {% endif %}
              </div>
            </div>
            {% endif %}
            {% if station.antennas.exists %}
            <div class="row">
              <div class="title">{% trans "Антенны" %}</div>
              <div class="description">
                {% if station.antennas.exists %}
                {% for antenna in station.antennas.all %}
                <span class="antenna-pill no-wrap"
                  data-toggle="tooltip"
                  data-placement="bottom"
                  title="{% for range in antenna.frequency_ranges.all %} {{ range.min_frequency|frq }} - {{ range.max_frequency|frq }}&#xA{% endfor %}">
                  {{ antenna.antenna_type.get_translated_name }} ({{ antenna.bands}})
                </span><br>
                {% endfor %}
                {% else %}
                <div class="empty-val"></div>
                {% endif %}
              </div>
            </div>
            {% endif %}
            {% if station.antennas.exists %}
            <div class="row">
              <div class="title">{% trans "Успешность" %}</div>
              <div class="description description-progress">
                {% if station.success_rate.total %}
                <div class="progress">
                  <a href="{% url 'base:observations_list' %}?future=0&bad=0&unknown=0&failed=0&station={{ station.id }}"
                    class="gs progress-bar pb-green"
                    role="progress-bar"
                    data-success-rate="{{ station.success_rate.good }}"
                    style="width: {{ station.success_rate.good }}%;"
                    title="{{ station.success_rate.good }}%"
                    data-toggle="tooltip">
                  </a>
                  <a href="{% url 'base:observations_list' %}?future=0&bad=0&good=0&failed=0&station={{ station.id }}"
                    class="gs progress-bar pb-orange"
                    role="progress-bar"
                    data-success-rate="{{ station.success_rate.unknown }}"
                    style="width: {{ station.success_rate.unknown }}%;"
                    title="{{ station.success_rate.unknown }}%"
                    data-toggle="tooltip">
                  </a>
                  <a href="{% url 'base:observations_list' %}?future=0&good=0&unknown=0&failed=0&station={{ station.id }}"
                    class="gs progress-bar pb-red"
                    role="progress-bar"
                    data-success-rate="{{ station.success_rate.bad }}"
                    style="width: {{ station.success_rate.bad }}%;"
                    title="{{ station.success_rate.bad }}%"
                    data-toggle="tooltip">
                  </a>
                </div>
                {% else %}
                <div class="empty-val"></div>
                {% endif %}
              </div>
            </div>
            {% endif %}
            <div class="row">
              <div class="title">{% trans "Наблюдения" %}</div>
              <div class="description">
                {% if station.total_obs %}
                <a href="{% url 'base:observations_list' %}?station={{ station.id }}">
                  {{ station.total_obs }}
                </a>
                {% else %}
                0
                {% endif %}
              </div>
            </div>
            <div class="row data-row">
              <div class="title">{% trans "Дата создания" %}</div>
              <div class="description"
                title="{{ station.created }}"
                data-toggle="tooltip"
                data-placement="bottom">
                {{ station.created|timesince_our }} {% trans "назад" %}
              </div>
            </div>
            {% if station.client_version %}
            <div class="row">
              <div class="title">{% trans "Версия клиента" %}</div>
              <div class="description">
                {% if station.client_version %}
                {{ station.client_version }}
                {% else %}
                <div class="empty-val"></div>
                {% endif %}
              </div>
            </div>
            {% endif %}
            <div class="row">
              <div class="description status">
                {% if station.get_status_display|lower == "online" %}
                <span class="badget badget-sm badget-blue">{% trans "В сети" %}</span>
                {% elif station.get_status_display|lower == "offline" %}
                <span class="badget badget-sm badget-red">{% trans "Не в сети" %}</span>
                {% elif station.get_status_display|lower == "testing" %}
                <span class="badget badget-sm badget-orange">{% trans "Тестируется" %}</span>
                {% endif %}
                {% if station.last_seen %}
                {% trans "Была в сети" %} {{ station.last_seen|timesince_our }} {% trans "назад" %}
                {% else %}
                {% trans "Еще не была в сети" %}
                {% endif %}
              </div>
            </div>
            <div class="row">
              <div class="title">{% trans "Время работы" %}</div>
              <div class="description no-wrap">
                {% display_sum_of_worktime station.id as worktime %}
                {{worktime}}
              </div>
            </div>
            {% if station.description %}
            <div class="station-description">{{ station.description }}</div>
            {% endif %}
          </div>
          <div class="station-media col row">
            <div class="col"
              id="station-view-image-container">
              <a href="{{ station.get_image }}"
                data-fancybox="station-image">
                <img src="{{ station.get_image }}"
                  class="station-view-image"
                  alt="{{ station.name }}">
              </a>
            </div>
            <div class="col"
              id="station-view-map-container">
              <div id="map-station"
                data-mapboxtoken="{{ mapbox_token }}"></div>
            </div>
          </div>
        </div>
      </div>
      {% if request.user == station.owner and station.client_id %}
      <div class="tab-pane"
        id="tab-configuration">
        <div class="content">{% trans "Базовая конфигурация" %}
          <div class="row cards">
            <div class="card">
              <div class="card-header">{% trans "Soapy RX устройство" %}</div>
              <div class="card-body">{{ station.satnogs_soapy_rx_device }}</div>
            </div>
            <div class="card">
              <div class="card-header">{% trans "Soapy антенна" %}</div>
              <div class="card-body">{{ station.satnogs_antenna }}</div>
            </div>
            <div class="card">
              <div class="card-header">{% trans "RX Sample Rate" %}</div>
              <div class="card-body">{{ station.satnogs_rx_samp_rate }}</div>
            </div>
            <div class="card">
              <div class="card-header">{% trans "RF усиление" %}</div>
              <div class="card-body">{{ station.satnogs_rf_gain }}</div>
            </div>
          </div>
        </div>
      </div>
      {% endif %}
      <div class="tab-pane"
        id="tab-future-passes">
        <div id="pass-predictions">
          <div class="row justify-content-between">
            <strong>{% trans "Будущие прохождения" %}</strong>
            <a id="btnFilter"
              class="btn btn-small btn-outline-blue"
              role="button"
              data-toggle="collapse"
              href="#collapseFilters"
              aria-expanded="false"
              aria-controls="collapseFilters">
              <span class="bi bi-funnel"
                aria-hidden="true"></span>
            </a>
          </div>
          <div class="row filter-1 justify-content-between">
            <div class="col">
              <label for="success-filter">{% trans "Процент успешности" %}
                <div class="slider-wrapper">
                  <input id="success-filter"
                    type="hidden">
                </div>
              </label>
            </div>
            <div class="col">
              <label for="elevation-filter">{% trans "Максимальная элевация" %}
                <div class="slider-wrapper">
                  <input id="elevation-filter"
                    type="hidden">
                </div>
              </label>
            </div>
            <div class="col">
              <label for="overlap-filter">{% trans "Наложение" %}
                <div class="slider-wrapper">
                  <input id="overlap-filter"
                    type="hidden">
                </div>
              </label>
            </div>
          </div>
          <div id="collapseFilters">
            <div class="row filter-2 collapse justify-content-between">
              <div class="col">
                <div class="row status-row">
                  <label class="btn btn-outline-blue-fill btn-sm"
                    aria-expanded="true"
                    aria-controls="future"
                    data-toggle="tooltip"
                    data-placement="bottom"
                    title="Неизвестные спутники">
                    <input class="status-filter"
                      type="checkbox"
                      name="unknown"
                      autocomplete="off"
                      checked>
                    {% trans "Неизвестные спутники" %}
                  </label>
                  <label class="btn btn-outline-orange-fill btn-sm"
                    aria-expanded="true"
                    aria-controls="future"
                    data-toggle="tooltip"
                    data-placement="bottom"
                    title="Неактивные спутники">
                    <input class="status-filter"
                      type="checkbox"
                      name="inactive"
                      autocomplete="off"
                      checked>
                    {% trans "Неактивные спутники" %}
                  </label>
                </div>
              </div>
              <div class="col frequency-col">
                {% if station.antennas.exists %}
                {% trans "Показывать диапазоны" %}:
                <div id="freq-container">
                  {% for antenna in station.antennas.all %}
                  {% for range in antenna.frequency_ranges.all %}
                  <label class="btn btn-outline-gray btn-sm"
                    aria-expanded="true"
                    aria-controls="future"
                    data-toggle="tooltip"
                    data-placement="bottom"
                    title="{{ range.min_frequency|frq }} - {{ range.max_frequency|frq }}">
                    <input class="freq-filter"
                      data-min="{{ range.min_frequency }}"
                      data-max="{{ range.max_frequency }}"
                      type="checkbox"
                      autocomplete="off"
                      checked>
                    <span> {{ range.min_frequency|frq }} - {{ range.max_frequency|frq }} </span>
                  </label>
                  {% endfor %}
                  {% endfor %}
                </div>
                {% endif %}
              </div>
            </div>
          </div>
          <div class="row calculate-btn">
            <button type="button"
              id="calculate-button"
              class="btn btn-big btn-outline-blue">
              <i class="bi bi-calculator-fill"
                aria-hidden="true"></i>
              {% trans "Рассчитать" %}
            </button>
          </div>
          <div class="row resulsts">
            <div class="table-wrapper col">
              <div class="loading-spinner">
                <div class="spinner">
                  <div class="bounce1"></div>
                  <div class="bounce2"></div>
                  <div class="bounce3"></div>
                </div>
                {% trans "Расчет будущих прохождений" %}
              </div>
              <table id="resTable"
                class="table hover d-none">
                <thead>
                  <th>{% trans "Название" %}</th>
                  <th>
                    <span aria-hidden="true"
                      data-toggle="tooltip"
                      data-placement="bottom"
                      title="{% trans 'Спутник поднимается над горизонтом' %}">{% trans "Восход" %}</span>
                  </th>
                  <th>
                    <span aria-hidden="true"
                      data-toggle="tooltip"
                      data-placement="bottom"
                      title="{% trans 'Спутник приближается к горизонту' %}">{% trans "Заход" %}</span>
                  </th>
                  <th>⤉ ⇴ ⤈</th>
                  <th>{% trans "Полярный график" %}</th>
                  {% if can_schedule %}
                  <th></th>
                  {% endif %}
                </thead>
                <tbody id="pass-predictions-results"
                  can_schedule="{{ can_schedule }}">
                </tbody>
              </table>
            </div>
          </div>
          <div class="row"
            id="prediction-results">
            <div class="col-md-12 notice"
              hidden>
              <span id="prediction-results-count"></span> {% trans "прохождений найдено" %}.
              <a id="open-all"
                href="#">{% trans "Открыть все для планирования" %}</a>.
            </div>
          </div>
        </div>
      </div>
      <div class="tab-pane"
        id="tab-station-log">
        <div class="row">
          <div class="col">
            <table class="table table-sm table-hover my-2">
              <thead>
                <th>{% trans "Статус" %}</th>
                <th>{% trans "Дата" %}</th>
                <th>{% trans "Время с изменения" %}</th>
              </thead>
              <tbody>
                {% for log in station_log %}
                <tr class="{{log.get_status_display|lower}}">
                  <td>
                    <span
                      class="badget badget-big badget-{{ log.get_status_display|lower }}">{{ log.get_status_for_logs }}</span>
                  </td>
                  <td>
                    <span>{{ log.changed|date:"Y-m-d H:i:s" }}</span>
                  </td>
                  <td>
                    <span>{{ log.changed|timesince_our }} {% trans "назад" %}</span>
                  </td>
                </tr>
                {% endfor %}
              </tbody>
            </table>
          </div>
        </div>
      </div>
      <div class="tab-pane"
        id="tab-station-stat">
        <div class="station-stat">
          <div class="station-stat__row">
            <div class="station-stat__item">
              <div class="station-stat__header">
                {% trans "Данные по высотам" %}
              </div>
              <div class="station-stat__chart">
                <img src="{{ station.stat.all_alt_svg.url }}"
                  class="station-stat__img">
              </div>
            </div>
            <div class="station-stat__item">
              <div class="station-stat__header">
                {% trans "Данные по азимутам" %}
              </div>
              <div class="station-stat__chart">
                <img src="{{ station.stat.all_az_svg.url }}"
                  class="station-stat__img">
              </div>
            </div>
          </div>
          <div class="station-stat__row">
            <div class="station-stat__item">
              <div class="station-stat__header">
                {% trans "Данные по азимуту с возвышением 30<=" %}
              </div>
              <div class="station-stat__chart">
                <img src="{{ station.stat.low_az_svg.url }}"
                  class="station-stat__img">
              </div>
            </div>
            <div class="station-stat__item">
              <div class="station-stat__header">
                {% trans "Визуализация полученных пакетов за месяц" %}
              </div>
              <div class="station-stat__chart">
                <img src="{{ station.stat.month_polar_svg.url }}"
                  class="station-stat__img">
              </div>
            </div>
          </div>
        </div>
      </div>
      {% csrf_token %}
      {% if request.user == station.owner %}
      <div class="tab-pane"
        id="tab-auto-scheduling">
        {% include 'includes/primary_schedule.html' %}
        {% include 'includes/second_schedule.html'%}
      </div>
      {% endif%}
    </div>
  </div>
</section>

<script src="{% static 'lib/mapbox-gl/dist/mapbox-gl.js' %}"></script>

{% endblock content %}

{% block modal %}

<!-- Hotkeys Modal -->
{% include 'includes/observation-hotkeys.html' %}

<!-- Satellite Modal -->
{% include 'includes/satellite.html' %}

{% endblock modal %}

{% block javascript %}
<script src="{% static 'lib/moment/min/moment.min.js' %}"></script>
<script src="{% static 'lib/jquery-ui-touch-punch/jquery.ui.touch-punch.min.js' %}"></script>
<script src="{% static 'lib/bootstrap-slider/dist/bootstrap-slider.min.js' %}"></script>
<script src="{% static 'lib/satellite.js/dist/satellite.min.js' %}"></script>
<script src="{% static 'lib/bootstrap-select/dist/js/bootstrap-select.min.js' %}"></script>
<script src="{% static 'lib/@fancyapps/ui/dist/fancybox/fancybox.umd.js' %}"></script>
<script src="{% static 'lib/d3/dist/d3.min.js' %}"></script>
<script src="{% static 'js/utc.js' %}"></script>
<script src="{% static 'js/polar_svg.js' %}"></script>
<script src="{% static 'js/station_view.js' %}"></script>
<script src="{% static 'js/gridsquare.js' %}"></script>
<script src="{% static 'js/satellite_modal.js' %}"></script>
<script src="{% static 'js/frequency_utils.js' %}"></script>
<script src="{% static 'js/autoschedule.js' %}"></script>
<script src="{% static 'js/autoschedule_second.js' %}"></script>

{% endblock javascript %}
